.PHONY: clean maintainer-clean install config package backup uninstall install-html info $(foreach lib,$(installlib), updatelib$(lib))

info: $(srcdir)/Documentation/cold.info ;

config: $(DEFAULTVARIABLES)

installdirs:
	@$(scriptdir)/mkdirp $(alldirs)

define INSTHTML
install-html:: installdirs
	$$(INSTALL_DATA) $$(srcdir)/Documentation/$1 $$(DESTDIR)$$(docdir)/html/$1
endef

define INSTLIB
install:: installdirs
	$$(INSTALL_PROGRAM) $1 $$(DESTDIR)$$(libdir)/$$(notdir $1)
	ln -sf $$(DESTDIR)$$(libdir)/$$(notdir $1) $$(DESTDIR)$$(libdir)/$$(basename $$(basename $$(notdir $1)))
	ln -sf $$(DESTDIR)$$(libdir)/$$(notdir $1) $$(DESTDIR)$$(libdir)/$$(basename $$(basename $$(basename $$(notdir $1))))
endef

define UPDATELIB
updatelib$$(strip $$(subst lib,,$$(basename $$(basename $$(basename $$(basename $$(basename $$(notdir $1)))))))): 
	$$(INSTALL_PROGRAM) $1 $$(DESTDIR)$$(libdir)/$$(notdir $1)
	ln -sf $$(DESTDIR)$$(libdir)/$$(notdir $1) $$(DESTDIR)$$(libdir)/$$(basename $$(basename $$(notdir $1)))
	ln -sf $$(DESTDIR)$$(libdir)/$$(notdir $1) $$(DESTDIR)$$(libdir)/$$(basename $$(basename $$(basename $$(notdir $1))))
endef


define INSTPROG
install:: installdirs
	$$(INSTALL_PROGRAM) $1 $$(DESTDIR)$$(bindir)/$$(notdir $1)
endef

define INSTDATA
install:: installdirs
	-$$(INSTALL_DATA) $$(srcdir)/$1 $$(DESTDIR)$$(mainsearchdir)/$1
endef

define INSTDOC
install:: installdirs
	$$(INSTALL_DATA) $$(srcdir)/Documentation/$1 $$(DESTDIR)$$(infodir)/$1
endef

$(foreach progfile,$(installbin),$(eval  $(call INSTPROG, $(progfile))))
$(foreach libfile,$(installlib),$(eval  $(call INSTLIB, $(libfile))))
$(foreach datfile,$(installdat),$(eval  $(call INSTDATA,$(datfile))))
$(foreach docfile,$(notdir $(installdoc)),$(eval  $(call INSTDOC,$(docfile))))
$(foreach docfile,$(notdir $(htmldocumentation)),$(eval  $(call INSTHTML,$(docfile))))

$(foreach libfile,$(installlib),$(eval  $(call UPDATELIB, $(libfile))))

install:: installdirs
	-ldconfig -n $(DESTDIR)$(libdir)


INSTALL-INFO=install-info

install:: installdirs
	-$(INSTALL-INFO) $(DESTDIR)$(infodir)/cold.info  $(DESTDIR)$(infodir)/dir

dist:
	tar -cf $(tarfilename) $(alldistfiles)
	gzip $(tarfilename)

backup: tarfilename=$(backupname)
backup: dist
	mv $(tarfilename).gz $(backupdir)/$(backupname)

uninstall:
	@echo 'Note that uninstall does not delete statefiles made by the program during execution. These must be manually deleted.'
	-$(INSTALL-INFO) --delete $(DESTDIR)$(infodir)/cold.info  $(DESTDIR)$(infodir)/dir
	-rm $(installedfiles)

clean:
	-rm *.o
	-rm $(PACKAGENAME)
	-rm configvars.h
	-rm $(DNAPROGNAME)
	-rm Utilities/$(UTILSETUPNAME)
	-rm Utilities/$(UTILREORDERMATNAME)
	-rm Utilities/$(UTILSUMMATNAME)
	-rm Output/Output.o

dist-clean: clean
	-rm $(automaticheaders)
	-rm variables
	-rm Documentation/cold.info
	-rm -r Documentation/cold/
	-$(MAKE) -C Libs clean

maintainer-clean: dist-clean
	-rm $(automaticheaders)
	-rm variables
	-rm Documentation/cold.info
	-rm -r Documentation/cold/

remove: dist clean uninstall
	-rm $(alldistfiles)
	-rmdir Data Models Utilities Documentation


